VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cls_Slider"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Compare Database
Option Explicit

'************************************************
'KLASSE: cls_Slider
'Beschreibung: Nachbau eines (schnen) Slidercontrols
'Das mit 3 Labels auf einem Formular auskommt.
'
'Autor:     Axel Prott (DeBePRO)
'Version:   1.0 vom 19.07.2013
'Frei verwendbar, solange dieser Header nicht
'entfernt wird.
'
'************************************************

'************************************************
'EVENTS
'************************************************
Public Event StartScrolling()
Public Event StopScrolling()
Public Event Changing(ByVal scrVal As Long)
Public Event AfterUpdate(ByVal NewValue As Long)

'************************************************
'KLASSENVARIABLEN
'************************************************
Private Type Tickpoint
    TP_lfd As Long
    TP_Value As Long
    TP_Twips As Long
End Type

Private b_Init As Boolean       'Wurde ich korrekt initialisiert (Controls)? !!!NOT USED YET!!!

Private Const cEventProc As String = "[EVENT PROCEDURE]"

Private m_minValue As Long
Private m_maxValue As Long

Private TickCount As Long           'Anzahl der Punkte (2..7 => 6)
Private Aerea() As Tickpoint        'Einzelne Wertpunkte
Private Const AereaMin As Long = 0  'Linke(Obere) Begrenzung
Private AereaMax As Long            'Rechte(Untere)Begrenzung

Private Const SmallStep As Long = 1 'ohne Funktion, nur der Vergleichbarkeit wg.
Private m_BigStep As Long           'Wie weit soll der Marker gehen, wenn auf die Box geklickt wird
Private SmallStepTwips As Long      'Schrittweite in Twips
Private BigStepTwips As Long        'Schrittweite in Twips f. groe Sprnge / wird berechne aber ohne Funktion

Private AktTickpoint As Tickpoint   'Beinhaltet den aktuellen Wert und die aktuelle Position in Twips

Private WithEvents slBox As Label
Attribute slBox.VB_VarHelpID = -1
Private WithEvents slMarker As Label
Attribute slMarker.VB_VarHelpID = -1
Private WithEvents slText As Label
Attribute slText.VB_VarHelpID = -1
Private m_slTextFormat As String
'#
Private m_lValue As Long
Private m_ShowScrollingText As Boolean


'************************************************
'PROPERTIES
'************************************************
'Minimum
Public Property Get MinValue() As Long
    MinValue = m_minValue
End Property
Public Property Let MinValue(ByVal lMinValue As Long)
    m_minValue = lMinValue
    If m_minValue < m_maxValue Then Call MakeArea
End Property

'Maximum
Public Property Get MaxValue() As Long
    MaxValue = m_maxValue
End Property
Public Property Let MaxValue(ByVal lMaxValue As Long)
    m_maxValue = lMaxValue
    If m_minValue < m_maxValue Then Call MakeArea
End Property

'Groe Aenderung
Public Property Get Bigchange() As Long
    Bigchange = m_BigStep
End Property
Public Property Let Bigchange(ByVal lBigchange As Long)
    m_BigStep = lBigchange
End Property

'Value
Public Property Get Value() As Long
    Value = AktTickpoint.TP_Value
End Property
Public Property Let Value(ByVal lValue As Long)
    Call SetValue(lValue)
End Property

Public Property Get ShowScrollingText() As Boolean
    ShowScrollingText = m_ShowScrollingText
End Property
Public Property Let ShowScrollingText(ByVal bShowScrollingText As Boolean)
    m_ShowScrollingText = bShowScrollingText
End Property

Public Property Get TextFormat() As String
    TextFormat = m_slTextFormat
End Property
Public Property Let TextFormat(ByVal sTextFormat As String)
    m_slTextFormat = sTextFormat
End Property


'************************************************
'KLASSE
'************************************************
Private Sub Class_Initialize()
    'Standardwerte
    m_minValue = 0
    m_maxValue = 10
    m_BigStep = 5
    m_ShowScrollingText = True
End Sub

Private Sub Class_Terminate()
    Set slBox = Nothing
    Set slMarker = Nothing
    Set slText = Nothing
End Sub


Public Sub Init(ByRef BoxLabel As Label, ByRef MarkerLabel As Label, ByRef TextLabel As Label)
    Set slBox = BoxLabel
    Set slMarker = MarkerLabel
    Set slText = TextLabel
    slBox.OnMouseDown = cEventProc
    slMarker.OnMouseDown = cEventProc
    slMarker.OnMouseMove = cEventProc
    slMarker.OnMouseUp = cEventProc
    'Standardwerte
'    slBox.Caption = ""
    slText.Visible = False
    'Berechnungen f. die Standardwerte
    Call MakeArea
End Sub


'************************************************
'STEUERELEMENTE
'************************************************
Private Sub slMarker_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'das Spektakel geht los
    Dim sText As String
    If Button = acLeftButton Then RaiseEvent StartScrolling
    slText.Left = slMarker.Left - ((slText.Width - slMarker.Width) / 2)     'Werte-Textlabel positionieren
    If m_ShowScrollingText Then
        
'#
        If Len(m_slTextFormat) > 0 Then
            sText = Replace(m_slTextFormat, "#", Str(AktTickpoint.TP_Value))
            slText.Caption = Eval(sText)
        Else
            slText.Caption = AktTickpoint.TP_Value
        End If
'/#
        slText.Visible = True                                               'Sichtbar?
    End If
End Sub


Private Sub slMarker_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim CurrentPos As Long
    Dim newPositionValue As Long
    Dim NewValue As Long
    Dim newTwips As Long
    Dim sText As String
    
    If Button = acLeftButton Then
        CurrentPos = AktTickpoint.TP_Twips + X - CLng(slMarker.Width / 2)
        newPositionValue = NextTickpoint(CurrentPos)        'nchstgelegenen Wert ermitteln
        newTwips = GetTwipsFromValue(newPositionValue)      'Position zum Wert
        slMarker.Left = slBox.Left + newTwips               'Marker setzen
        slText.Left = slMarker.Left _
                      - ((slText.Width - slMarker.Width) / 2) 'Text setzen
        
        If newPositionValue <> AktTickpoint.TP_Value Then   'Wenn sich der Wert geaendert hat
            AktTickpoint.TP_Value = newPositionValue        'neuen Wert und Position speichern
            AktTickpoint.TP_Twips = newTwips                'sonst gibt es ein hin- und hergehopse
'#
    If Len(m_slTextFormat) > 0 Then
        sText = Replace(m_slTextFormat, "#", Str(newPositionValue))
        slText.Caption = Eval(sText)
    Else
        slText.Caption = newPositionValue
    End If
'/#            slText.Caption = Format(newPositionValue \ 60, "00") & ":" & Format(newPositionValue Mod 60, "00")            'Text aktualisieren
            RaiseEvent Changing(newPositionValue)
        End If
    End If
End Sub


Private Sub slMarker_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Alles vorbei und getan, nur noch Fertigmeldung und ein wenig aufraeumen
    If Button = acLeftButton Then
        RaiseEvent StopScrolling                                'es wird nicht mehr gescrollt
        RaiseEvent AfterUpdate(AktTickpoint.TP_Value)           'Updatemeldung
        slText.Visible = False                                  'Text verstecken
    End If
End Sub


Private Sub slBox_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Select Case slMarker.Left - (slBox.Left + X)
        Case Is < 0 'rechts vom Marker geklickt => Value um BigStep erhoehen
            If AktTickpoint.TP_Value + m_BigStep <= m_maxValue Then
                Call SetValue(AktTickpoint.TP_Value + m_BigStep)
            Else
                Call SetValue(m_maxValue)
            End If
        Case Is > 0 'links vom Marker geklickt => Value um Bigstep vermindern
            If AktTickpoint.TP_Value - m_BigStep >= m_minValue Then
                Call SetValue(AktTickpoint.TP_Value - m_BigStep)
            Else
                Call SetValue(m_minValue)
            End If
    End Select
    RaiseEvent AfterUpdate(AktTickpoint.TP_Value)        'Meldung abschicken
End Sub



'************************************************
'PRIVATE SUBs UND FUNKTIONEN
'************************************************
Private Sub MakeArea()
'Berechnungen zur Aufteilung
    Dim i As Long, lRest As Long
    
    TickCount = m_maxValue - m_minValue
    AereaMax = slBox.Width - slMarker.Width       'Breite minus der Box-Breite des Markers als Slidergebiet
    SmallStepTwips = Fix(AereaMax / TickCount)
    BigStepTwips = SmallStepTwips * m_BigStep
    
    ReDim Aerea(TickCount)                          'Datenfeld mit Werten und Abstaenden
    For i = 0 To TickCount
        Aerea(i).TP_lfd = i
        Aerea(i).TP_Value = m_minValue + i
        Aerea(i).TP_Twips = i * SmallStepTwips
    Next

    'Es ist wahrscheinlich, dass beim Teilen des Slidergebiets durch die Anzahl der Ticks ein Rest brigbleibt
    'Rest aufteilen, die letzten bekommen jeweils 1 Twip dazu
    lRest = AereaMax Mod TickCount
    For i = TickCount To TickCount - (AereaMax Mod TickCount) Step -1
        Aerea(i).TP_Twips = Aerea(i).TP_Twips + lRest
        lRest = lRest - 1
    Next i
End Sub


Private Sub SetValue(ByVal NewValue As Long)
'Setzen des Wertes von Aussen und Innen
    Dim twips As Long
    twips = GetTwipsFromValue(NewValue)     'Position bestimmen
    slMarker.Left = slBox.Left + twips      'Marker setzen
    AktTickpoint.TP_Twips = twips           'Aktuellen Punkt sichern
    AktTickpoint.TP_Value = NewValue
'    RaiseEvent AfterUpdate(NewValue)        'Meldung abschicken
End Sub


Private Function NextTickpoint(ByVal lTwips As Long) As Long
'Liefert zu einem Verschiebewert des Markers den nchsten Punkt
'Parameter: lTwips = Abstand linke Seite Marker zur linken Seite Box
'Rueckgabe: Value des gefundenen Punktes
    Dim i As Long
    Dim tmpDif As Long
    Dim resValue As Long
    
    'Maus ist links aus der Box
    If lTwips < 0 Then
        NextTickpoint = m_minValue
        Exit Function
    End If
    
    'Maus ist in der Box oder rechts davon
    'Wir suchen den Punkt mit dem kleinsten Abstand aus unserem Gebietsarray
    'erste Differenz, erster Punkt
    tmpDif = Abs(Aerea(0).TP_Twips - Abs(lTwips))
    resValue = Aerea(0).TP_Value
    'weitere Differenzen
    For i = LBound(Aerea) + 1 To UBound(Aerea)
        If Abs(Aerea(i).TP_Twips - Abs(lTwips)) < tmpDif Then
            tmpDif = Abs(Aerea(i).TP_Twips - Abs(lTwips))
            resValue = Aerea(i).TP_Value
        Else
            Exit For
        End If
    Next i
    NextTickpoint = resValue
End Function

Private Function GetValueFromTwips(ByVal lTwips As Long) As Long
    'Liefert den Twips den entspr. Wert
    Dim i As Long
    For i = LBound(Aerea) To UBound(Aerea)
        If Aerea(i).TP_Twips = lTwips Then
            GetValueFromTwips = Aerea(i).TP_Value
            Exit For
        End If
    Next i
End Function

Private Function GetTwipsFromValue(ByVal lValue As Long) As Long
    'Liefert zu einem Wert die entspr. Twips
    Dim i As Long
    For i = LBound(Aerea) To UBound(Aerea)
        If Aerea(i).TP_Value = lValue Then
            GetTwipsFromValue = Aerea(i).TP_Twips
            Exit For
        End If
    Next i
End Function


